// WARNING: This file is auto-generated and any changes to it will be overwritten
import java.util.*;
import greenfoot.*;
import java.awt.Color;

/**
 * The bloodstream is the setting for our White Blood Cell scenario. It's a place where blood cells, bacteria and viruses float around.
 * 
 * Author: mik
 * Version: 1.0 (Stride)
 */
public class Bloodstream extends World
{
    private int score;
    private int time;

    /**
     * Constructor: Set up the starting objects.
     */
    public Bloodstream()
    {
        super(780, 360, 1);
        setPaintOrder(Border.class);
        prepare();
        score = 0;
        time = 2000;
        showScore();
        showTime();
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3) {
            addObject( new  Bacteria(), 779, Greenfoot.getRandomNumber(360));
        }
        
        if (Greenfoot.getRandomNumber(100) < 1) {
            addObject( new  Lining(), 779, 0);
        }
        
        if (Greenfoot.getRandomNumber(100) < 1) {
            addObject( new  Lining(), 779, 359);
        }
        
        if (Greenfoot.getRandomNumber(100) < 1) {
            addObject( new  Virus(), 779, Greenfoot.getRandomNumber(360));
        }
        
        if (Greenfoot.getRandomNumber(100) < 6) {
            addObject( new  RedCell(), 779, Greenfoot.getRandomNumber(360));
        }
        
        countTime();
    }

    /**
     * Add some points to our current score. (May be negative.)
     * If the score falls below 0, game's up.
     */
    public void addScore(int points)
    {
        score = score + points;
        showScore();
        if (score < 0) {
            Greenfoot.playSound("game-over.wav");
            Greenfoot.stop();
        }
    }

    /**
     * Show our current score on screen.
     */
    private void showScore()
    {
        showText("Score: " + score, 80, 25);
    }

    /**
     * Count down the game time and display it. Stop the game 
     * with a winning message when time is up.
     */
    private void countTime()
    {
        time = time - 1;
        showTime();
        if (time == 0) {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    /**
     * Show the remaining game time on screen.
     */
    public void showTime()
    {
        showText("Time: " + time, 700, 25);
    }

    /**
     * Show the end-of-game message on screen.
     */
    public void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score: " + score + " points", 390, 170);
    }

    /**
     * Prepare the world for the start of the program. In this case: Create a white blood cell and the lining at the edge of the blood stream.
     */
    private void prepare()
    {
        WhiteCell whitecell =  new  WhiteCell();
        addObject(whitecell, 128, 179);
        
        addObject( new  Lining(), 126, 1);
        addObject( new  Lining(), 342, 5);
        addObject( new  Lining(), 589, 2);
        addObject( new  Lining(), 695, 2);
        addObject( new  Lining(), 114, 359);
        addObject( new  Lining(), 295, 353);
        addObject( new  Lining(), 480, 358);
        addObject( new  Lining(), 596, 359);
        addObject( new  Lining(), 740, 354);
        
        Border border =  new  Border();
        addObject(border, 0, 180);
        Border border2 =  new  Border();
        addObject(border2, 770, 180);
    }
}
